package = "OiL"
version = "0.6"
source = {
	url = "http://www.tecgraf.puc-rio.br/~maia/lua/packs/oil-0.6.tar.gz",
}
description = {
	summary = "An Object Request Broker in Lua",
	detailed = [[
		OiL stands for ORB in Lua and it is a very portable and lightweight
		implementation of easy-to-use object request brokers (ORB) written in Lua.
		OiL ORBs are made of assembled components that can be selectively chosen or
		replaced to create ORBs with different features. Currently, it provides
		components that support cooperative multithreading (with coroutines),
		interoperability with CORBA (through IIOP), interception of CORBA
		invocations, etc.
	]],
	license = "MIT/X11",
	homepage = "http://www.tecgraf.puc-rio.br/~maia/lua/oil",
	maintainer = "Renato Maia <maia@tecgraf.puc-rio.br>",
}
dependencies = {
	"lua >= 5.1",
	"struct >= 1.2",
	"luasocket >= 2.0",
	"tuple >= 1.0beta",
	"loop >= 3.0",
	"looplib >= 2.0beta",
	"loopcomp >= 1.0beta",
	"cothread >= 0.1",
}
build = {
	type = "none",
	install = {
		lua = {
			["luaidl.lex"] = "lua/luaidl/lex.lua",
			["luaidl.pre"] = "lua/luaidl/pre.lua",
			["luaidl.sin"] = "lua/luaidl/sin.lua",
			["luaidl"] = "lua/luaidl.lua",
			["oil.assert"] = "lua/oil/assert.lua",
			["oil.builder"] = "lua/oil/builder.lua",
			["oil.component"] = "lua/oil/component.lua",
			["oil.corba.giop.Channel"] = "lua/oil/corba/giop/Channel.lua",
			["oil.corba.giop.Codec"] = "lua/oil/corba/giop/Codec.lua",
			["oil.corba.giop.CodecGen"] = "lua/oil/corba/giop/CodecGen.lua",
			["oil.corba.giop.Exception"] = "lua/oil/corba/giop/Exception.lua",
			["oil.corba.giop.Indexer"] = "lua/oil/corba/giop/Indexer.lua",
			["oil.corba.giop.Listener"] = "lua/oil/corba/giop/Listener.lua",
			["oil.corba.giop.Referrer"] = "lua/oil/corba/giop/Referrer.lua",
			["oil.corba.giop.Requester"] = "lua/oil/corba/giop/Requester.lua",
			["oil.corba.giop"] = "lua/oil/corba/giop.lua",
			["oil.corba.idl.Compiler"] = "lua/oil/corba/idl/Compiler.lua",
			["oil.corba.idl.Importer"] = "lua/oil/corba/idl/Importer.lua",
			["oil.corba.idl.Indexer"] = "lua/oil/corba/idl/Indexer.lua",
			["oil.corba.idl.ir"] = "lua/oil/corba/idl/ir.lua",
			["oil.corba.idl.Registry"] = "lua/oil/corba/idl/Registry.lua",
			["oil.corba.idl.sysex"] = "lua/oil/corba/idl/sysex.lua",
			["oil.corba.idl"] = "lua/oil/corba/idl.lua",
			["oil.corba.iiop.Profiler"] = "lua/oil/corba/iiop/Profiler.lua",
			["oil.corba.intercepted.Listener"] = "lua/oil/corba/intercepted/Listener.lua",
			["oil.corba.intercepted.Requester"] = "lua/oil/corba/intercepted/Requester.lua",
			["oil.corba.intercepted.servicecontext"] = "lua/oil/corba/intercepted/servicecontext.lua",
			["oil.corba.services.event.ConsumerAdmin"] = "lua/oil/corba/services/event/ConsumerAdmin.lua",
			["oil.corba.services.event.EventFactory"] = "lua/oil/corba/services/event/EventFactory.lua",
			["oil.corba.services.event.EventQueue"] = "lua/oil/corba/services/event/EventQueue.lua",
			["oil.corba.services.event.ProxyPushConsumer"] = "lua/oil/corba/services/event/ProxyPushConsumer.lua",
			["oil.corba.services.event.ProxyPushSupplier"] = "lua/oil/corba/services/event/ProxyPushSupplier.lua",
			["oil.corba.services.event.SingleDeferredDispatcher"] = "lua/oil/corba/services/event/SingleDeferredDispatcher.lua",
			["oil.corba.services.event.SingleSynchronousDispatcher"] = "lua/oil/corba/services/event/SingleSynchronousDispatcher.lua",
			["oil.corba.services.event.SupplierAdmin"] = "lua/oil/corba/services/event/SupplierAdmin.lua",
			["oil.corba.services.event"] = "lua/oil/corba/services/event.lua",
			["oil.corba.services.naming"] = "lua/oil/corba/services/naming.lua",
			["oil.Exception"] = "lua/oil/Exception.lua",
			["oil.kernel.base.Acceptor"] = "lua/oil/kernel/base/Acceptor.lua",
			["oil.kernel.base.Channels"] = "lua/oil/kernel/base/Channels.lua",
			["oil.kernel.base.Connector"] = "lua/oil/kernel/base/Connector.lua",
			["oil.kernel.base.Dispatcher"] = "lua/oil/kernel/base/Dispatcher.lua",
			["oil.kernel.base.DNS"] = "lua/oil/kernel/base/DNS.lua",
			["oil.kernel.base.Proxies.asynchronous"] = "lua/oil/kernel/base/Proxies/asynchronous.lua",
			["oil.kernel.base.Proxies.protected"] = "lua/oil/kernel/base/Proxies/protected.lua",
			["oil.kernel.base.Proxies.synchronous"] = "lua/oil/kernel/base/Proxies/synchronous.lua",
			["oil.kernel.base.Proxies.utils"] = "lua/oil/kernel/base/Proxies/utils.lua",
			["oil.kernel.base.Proxies"] = "lua/oil/kernel/base/Proxies.lua",
			["oil.kernel.base.Receiver"] = "lua/oil/kernel/base/Receiver.lua",
			["oil.kernel.base.Servants"] = "lua/oil/kernel/base/Servants.lua",
			["oil.kernel.base.Sockets"] = "lua/oil/kernel/base/Sockets.lua",
			["oil.kernel.cooperative.Connector"] = "lua/oil/kernel/cooperative/Connector.lua",
			["oil.kernel.cooperative.Receiver"] = "lua/oil/kernel/cooperative/Receiver.lua",
			["oil.kernel.cooperative.Sockets"] = "lua/oil/kernel/cooperative/Sockets.lua",
			["oil.kernel.cooperative.Tasks"] = "lua/oil/kernel/cooperative/Tasks.lua",
			["oil.kernel.intercepted.Listener"] = "lua/oil/kernel/intercepted/Listener.lua",
			["oil.kernel.intercepted.Requester"] = "lua/oil/kernel/intercepted/Requester.lua",
			["oil.kernel.lua.Dispatcher"] = "lua/oil/kernel/lua/Dispatcher.lua",
			["oil.kernel.lua.Proxies"] = "lua/oil/kernel/lua/Proxies.lua",
			["oil.kernel.typed.Dispatcher"] = "lua/oil/kernel/typed/Dispatcher.lua",
			["oil.kernel.typed.Proxies"] = "lua/oil/kernel/typed/Proxies.lua",
			["oil.kernel.typed.Servants"] = "lua/oil/kernel/typed/Servants.lua",
			["oil.ludo.Channel"] = "lua/oil/ludo/Channel.lua",
			["oil.ludo.Codec"] = "lua/oil/ludo/Codec.lua",
			["oil.ludo.CodecByRef"] = "lua/oil/ludo/CodecByRef.lua",
			["oil.ludo.Listener"] = "lua/oil/ludo/Listener.lua",
			["oil.ludo.Referrer"] = "lua/oil/ludo/Referrer.lua",
			["oil.ludo.Requester"] = "lua/oil/ludo/Requester.lua",
			["oil.oo"] = "lua/oil/oo.lua",
			["oil.port"] = "lua/oil/port.lua",
			["oil.properties"] = "lua/oil/properties.lua",
			["oil.protocol.Channel"] = "lua/oil/protocol/Channel.lua",
			["oil.protocol.Listener"] = "lua/oil/protocol/Listener.lua",
			["oil.protocol.Request"] = "lua/oil/protocol/Request.lua",
			["oil.protocol.Requester"] = "lua/oil/protocol/Requester.lua",
			["oil.verbose"] = "lua/oil/verbose.lua",
			["oil"] = "lua/oil.lua",
		},
	},
	install = {
		bin = {
			"lua/idl2lua.lua",
			"demo/cos/ird.lua",
			"demo/cos/nsd.lua",
			"demo/cos/channeld.lua",
		},
	},
}
